<template>
  <section class="h-dvh mx-4">
    <v-scroll-x-reverse-transition leave-absolute>
      <FloatingContainer
        v-if="!targetLogin && !isPinShown"
        class="flex items-center h-full"
      >
        <UnknownLogin @account-saved="isPinShown = true" />
      </FloatingContainer>
    </v-scroll-x-reverse-transition>

    <v-scroll-x-reverse-transition leave-absolute>
      <FloatingContainer
        v-if="targetLogin && !isPinShown"
        class="flex items-center h-full"
      >
        <SavedLogin
          @continue-click="isPinShown = true"
          @account-change="onAccountChange"
        />
      </FloatingContainer>
    </v-scroll-x-reverse-transition>

    <v-scroll-x-reverse-transition leave-absolute>
      <FloatingContainer
        v-if="isPinShown"
        class="flex items-center h-full"
      >
        <LoginPin @account-change="onAccountChange" />
      </FloatingContainer>
    </v-scroll-x-reverse-transition>
  </section>
</template>

<script setup lang="ts">
import { onBeforeMount, ref } from 'vue';
import { useRouter } from 'vue-router';

import FloatingContainer from '@/components/layout/FloatingContainer.vue';
import UnknownLogin from '@/pages/login/UnknownLogin.vue';
import SavedLogin from '@/pages/login/SavedLogin.vue';
import LoginPin from '@/pages/login/LoginPin.vue';

import { useAuth } from '@/composables';
import { HttpClient } from '@/http';

const auth = useAuth();
const router = useRouter();

const targetLogin = ref(auth.getLogin());
const isPinShown = ref(false);

const onAccountChange = () => {
  targetLogin.value = '';
  isPinShown.value = false;
};

onBeforeMount(async () => {
  const { data: { values: { isAppInitialized = true } = {} } } = await (
    HttpClient.get('/v1/auth/setup')
  );

  if (!isAppInitialized) {
    router.push('/setup');
  }
});
</script>